unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls,
  System.Win.ScktComp, IdContext, IdCustomTCPServer, IdTCPServer,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient;

const
  Host = '127.0.0.1';
  Port = 1001;

type
  TForm1 = class(TForm)
    BSelectFile: TButton;
    OpenDialog1: TOpenDialog;
    PBServer: TProgressBar;
    PBClient: TProgressBar;
    LServerStatus: TLabel;
    BFileReceive: TButton;
    LClientStatus: TLabel;
    LClientProgress: TLabel;
    LServerProgress: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    IdTCPClient1: TIdTCPClient;
    IdTCPServer1: TIdTCPServer;
    procedure FormDestroy(Sender: TObject);
//------------------------------------Server------------------------------------
    procedure BSelectFileClick(Sender: TObject);
    procedure IdTCPServer1Connect(AContext: TIdContext);
    procedure IdTCPServer1Disconnect(AContext: TIdContext);
    procedure IdTCPServer1Execute(AContext: TIdContext);
//------------------------------------Client------------------------------------
    procedure BFileReceiveClick(Sender: TObject);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure IdTCPClient1Disconnected(Sender: TObject);
    procedure IdTCPClient1SocketAllocated(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FName: String;

implementation

{$R *.dfm}

procedure TForm1.FormDestroy(Sender: TObject);
begin
  IdTCPServer1.Active := False;
end;
//------------------------------------Server------------------------------------
procedure TForm1.BSelectFileClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    FName := OpenDialog1.FileName;
    //  
    IdTCPServer1.DefaultPort := Port;
    IdTCPServer1.Active := True;

    LServerStatus.Caption := ' ...';
  end;
end;

procedure TForm1.IdTCPServer1Connect(AContext: TIdContext);
begin
  LServerStatus.Caption := '...';
end;

procedure TForm1.IdTCPServer1Disconnect(AContext: TIdContext);
begin
  LServerStatus.Caption := ' ';
end;

procedure TForm1.IdTCPServer1Execute(AContext: TIdContext);
var
  FS: TFileStream;
begin
  AContext.Connection.Socket.WriteLn(FName);

  FS := TFileStream.Create(FName, fmOpenRead or fmShareDenyNone); // 
  try
    AContext.Connection.Socket.Write(FS);
  finally
    FreeAndNil(FS);
  end;

  LClientStatus.Caption := ' ';
end;
// ------------------------------------Client------------------------------------
procedure TForm1.BFileReceiveClick(Sender: TObject);
begin
  //  
  IdTCPClient1.Host := Host;
  IdTCPClient1.Port := Port;
  IdTCPClient1.Connect;
end;

procedure TForm1.IdTCPClient1Connected(Sender: TObject);
begin
  LClientStatus.Caption := '...';
end;

procedure TForm1.IdTCPClient1Disconnected(Sender: TObject);
begin
  LClientStatus.Caption := ' ';
end;

procedure TForm1.IdTCPClient1SocketAllocated(Sender: TObject);
var
  FS: TFileStream;
  FName: String;
begin
  FName := IdTCPClient1.IOHandler.ReadLn;

  FS := TFileStream.Create('Downloads\' + ExtractFileName(FName), fmCreate); // 
  try
    IdTCPClient1.IOHandler.ReadStream(FS, -1, True); //   
  finally
    FreeAndNil(FS);;
  end;

  IdTCPClient1.Disconnect;

  LServerStatus.Caption := ' ';
end;

end.
